91超碰碰碰碰久久久久久综合_超碰av人澡人澡人澡人澡人掠_国产黄大片在线观看画质优化_txt小说免费全本

溫馨提示×

溫馨提示×

您好,登錄后才能下訂單哦!

密碼登錄×
登錄注冊×
其他方式登錄
點擊 登錄注冊 即表示同意《億速云用戶服務條款》

Revit怎么導出其他文件格式

發布時間:2021-07-23 14:58:43 來源:億速云 閱讀:690 作者:chen 欄目:大數據

這篇文章主要介紹“Revit怎么導出其他文件格式”,在日常操作中,相信很多人在Revit怎么導出其他文件格式問題上存在疑惑,小編查閱了各式資料,整理出簡單好用的操作方法,希望對大家解答”Revit怎么導出其他文件格式”的疑惑有所幫助!接下來,請跟著小編一起來學習吧!

Revit 可以導出多種其他文件格式,比如:DWG,DWF,IFC,NWC等等,主要通過API:doc.Export()方法.

實例代碼:

 public class ExportToOtherCommand : IExternalCommand
    {
        public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
        {
            UIApplication uiapp = commandData.Application;
            UIDocument uidoc = uiapp.ActiveUIDocument;
            Document doc = uidoc.Document;

            string projectName = Path.GetFileNameWithoutExtension(doc.PathName);
            string viewName = doc.ActiveView.Name;

            ////導出Dwf
            //using (Transaction trans = new Transaction(doc, "Export to Dwf file"))
            //{
            //    trans.Start();

            //    ExportToDWF(doc, $"D:\\Shared\\{projectName}_{viewName}.dwf");

            //    trans.Commit();
            //}

            ////導出Nwc
            //ExportToNwc(doc, $"D:\\Shared\\{projectName}_{viewName}.nwc");


            ExportToDwg(doc, $"D:\\Shared\\{projectName}_{viewName}.dwg",false);

            return Result.Succeeded;
        }

        /// <summary>
        /// 導出Nwc文件,不需要開啟事務
        /// </summary>
        /// <param name="document"></param>
        /// <param name="pathFullName"></param>

        public void ExportToNwc(Document document, string pathFullName)
        {
            NavisworksExportOptions nweOptions = new NavisworksExportOptions();
            nweOptions.ExportScope = NavisworksExportScope.Model;
            nweOptions.ViewId = document.ActiveView.Id;
            //導出是否包括鏈接模型
            nweOptions.ExportLinks = true;
            //判斷是否安裝了Navisworks
            bool isExporterAvailable = OptionalFunctionalityUtils.IsNavisworksExporterAvailable();
            if (isExporterAvailable)
            {
                string folder = Path.GetDirectoryName(pathFullName);
                string name = Path.GetFileNameWithoutExtension(pathFullName);
                document.Export(folder, name, nweOptions);
            }
            else
            {
                TaskDialog.Show("tip", "導出失敗!沒有安裝Navisworks");
            }
        }

        /// <summary>
        /// 導出dwf , 導出需要開啟事務
        /// </summary>
        /// <param name="document"></param>
        /// <param name="pathFullName"></param>
        /// <param name="isActiveView"></param>
        public void ExportToDWF(Document document, string pathFullName, bool isActiveView = true)
        {
            FilteredElementCollector collector = new FilteredElementCollector(document);
            collector.OfClass(typeof(View)).OfCategory(BuiltInCategory.OST_Views);

            DWFExportOptions dwfOptions = new DWFExportOptions
            {
                CropBoxVisible = true,
                ExportingAreas = true,
                ExportTexture = false
            };

            ViewSet views = new ViewSet();
            if (isActiveView)
            {
                views.Insert(document.ActiveView);
            }
            else
            {
                //多個視圖
                foreach (View view in collector.ToElements())
                {
                    if (view.CanBePrinted)
                    {
                        views.Insert(view);
                    }
                }
            }

            string folder = Path.GetDirectoryName(pathFullName);
            string name = Path.GetFileNameWithoutExtension(pathFullName);

            document.Export(folder,name, views, dwfOptions);
        }


        public void ExportToDwg(Document document, string pathFullName, bool isActiveView = true)
        {
            FilteredElementCollector collector = new FilteredElementCollector(document);
            collector.OfClass(typeof(View)).OfCategory(BuiltInCategory.OST_Views);

            DWGExportOptions dwgOptions = new DWGExportOptions
            {
                FileVersion = ACADVersion.R2010,
            };

            string folder = Path.GetDirectoryName(pathFullName);
            string name = Path.GetFileNameWithoutExtension(pathFullName);

            List<ElementId> viewIds = new List<ElementId>();
            if (isActiveView)
            {
                viewIds.Add(document.ActiveView.Id);
            }
            else
            {
                //多個視圖
                foreach (View view in collector.ToElements())
                {
                    if (view.CanBePrinted)
                    {
                        viewIds.Add(view.Id);
                    }
                }
            }

            document.Export(folder, name, viewIds, dwgOptions);
        }
    }

到此,關于“Revit怎么導出其他文件格式”的學習就結束了,希望能夠解決大家的疑惑。理論與實踐的搭配能更好的幫助大家學習,快去試試吧!若想繼續學習更多相關知識,請繼續關注億速云網站,小編會繼續努力為大家帶來更多實用的文章!

向AI問一下細節

免責聲明:本站發布的內容(圖片、視頻和文字)以原創、轉載和分享為主,文章觀點不代表本網站立場,如果涉及侵權請聯系站長郵箱:is@yisu.com進行舉報,并提供相關證據,一經查實,將立刻刪除涉嫌侵權內容。

AI

宁津县| 藁城市| 台安县| 临潭县| 怀仁县| 资讯| 班戈县| 松原市| 永福县| 贵州省| 顺昌县| 杭锦后旗| 青海省| 和林格尔县| 西乌| 黄陵县| 洪雅县| 朔州市| 顺平县| 兴国县| 遂川县| 尚义县| 临邑县| 光泽县| 定陶县| 高安市| 高平市| 米脂县| 乐平市| 东阳市| 阿拉尔市| 阜新市| 台南县| 涞源县| 易门县| 邵东县| 万宁市| 阜宁县| 东台市| 卓资县| 平邑县|